
//+------------------------------------------------------------------+
//|                                              ZZLengthAndDiff.mq4 |
//|                         Based on Original ZZ indicator Metaquotes|
//|                         Requires Original ZZ indicator Metaquotes|
//|                   Initial Mod Stephen Ambatoding forexfactory.com|
//|                       This Mod Brooky @ www.Brooky-Indicators.com|
//+---------------------------------------------------------------------------+
//|  Coding notes                                                             |
//|  (d1z-d2z)/Pip is the Distance between HH and LL                          |
//|  (d1z-zz)/Pip  is the Distance between HH and Last HH or Last LL and LL   |
//+---------------------------------------------------------------------------+
 

#property copyright "Copyright  2009, Stephen Ambatoding."
#property link      "sangmane@forexfactory.com"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

#property indicator_width1 2

extern int varExtDepth=12;
extern int varExtDeviation=5;
extern int varExtBackstep=3;
extern double label.space =10;


extern bool see.price = true;
extern int History = 1000;
extern color FontColor = Blue;
extern string use.font = "Arial";
extern int font.size = 9;
extern double label.angle = -90;
double Pip;
double zzdisplay[];

string price.display = "";
static double oldLabelPos;
//-------------
int init()
  {
  
   SetIndexStyle(0,DRAW_ARROW);
      SetIndexArrow(0,115);//short arrow
         SetIndexBuffer(0,zzdisplay);
            SetIndexEmptyValue(0,0.0);   
  
  
    if(Digits==3 || Digits==5) Pip = 10*Point;
    else Pip = Point;
    IndicatorDigits(Digits+1);   
    return(0);
  }
//=====================================================================
int deinit()
  {
   string ObjName;
   for(int i=ObjectsTotal()-1; i>=0; i--)
   {
     ObjName = ObjectName(i);
     if(StringFind(ObjName,"ZZLabel",0)>=0)ObjectDelete(ObjName);
       
   }
   
   Comment("");
   return(0);
  }
//=======================================================================
int start()
  {
   int i, k, limit, counted_bars=IndicatorCounted();
   limit = MathMin(History,Bars-counted_bars-1);
   double zz;
   color ObjColor;
   for(i=limit; i>=0; i--)
   {
     k = i;
     double d1=0,d2=0,d3=0,d4=0;
     datetime t1=0,t2=0,t3=0,t4=0;
     
     double d1z=0,d2z=0,d3z=0,d4z=0;
     datetime t1z=0,t2z=0,t3z=0,t4z=0;     
     
     while(k<Bars-1)
     {
       zz = iCustom(NULL,0,"ZigZag",varExtDepth,varExtDeviation,varExtBackstep,0,k);
       zzdisplay[k]=zz;
       
       if(zz!=0)
       {         


         d1z = d2z;d2z = d3z; d3z = zz;
         t1z = t2z;t2z = t3z; t3z = Time[k]; 
       }
       if(d1z>0) break;
       k++;  
     }
     
     
     
     if(d1z==0) continue;
     double LabelPos;
     
     int ib = iBarShift(NULL,0,t1z);
     int ib2 = iBarShift(NULL,0,t2z);
     int checkit = MathMin(varExtDepth,(ib2-ib));
     string placeObjName = "";//+k+""
     string ObjName = "";//+k+""
     
     
     
     if(!see.price)  price.display = "";
     if(d1z>d2z) 
     {
     LabelPos = NormalizeDouble(High[ib]+(label.space*Pip),Digits);//;
     placeObjName = "H";
     ObjName = "ZZLabel"+placeObjName+Time[i];
         for(int x=checkit-1; x>=0; x--)
         {
         string xObjName = "ZZLabel"+placeObjName+Time[x];//+k+""x
         if(d1z>d2z && Time[i]>t1z && LabelPos>=High[ib]) 
            {
            
            ObjectDelete(xObjName);
            }
         
         
         }
     if(see.price) price.display = DoubleToStr(High[ib],Digits);
     oldLabelPos = LabelPos;
     
     }


    if(d1z<d2z )
     {
     
     LabelPos = NormalizeDouble(Low[ib]-(label.space*Pip),Digits);
     placeObjName = "L";
     ObjName = "ZZLabel"+placeObjName+Time[i];
     
         for(int y=checkit-1; y>=0; y--)
         {
          string yObjName = "ZZLabel"+placeObjName+Time[y];
         if(d1z<d2z && Time[i]>t1z && LabelPos<=Low[ib])
            {
            ObjectDelete(yObjName);
            
            }
         
         
         }
      if(see.price) price.display = DoubleToStr(Low[ib],Digits);   
      oldLabelPos = LabelPos;   
         
     }

     

     
     if(zz!=0)
     
     double ratio = (((d1z-d2z)+0.0000001)/Pip)/(((d1z-zz)+0.0000001)/Pip);
     
     if(ObjectFind(ObjName)<0)
     {
       ObjectCreate(ObjName,OBJ_TEXT,0,t1z,LabelPos);
       ObjectSetText(ObjName,DoubleToStr(((d1z-d2z)+0.0000001)/Pip,0)+" ("+DoubleToStr(((d1z-zz)+0.0000001)/Pip,0)+")"+" "+price.display+" ("+DoubleToStr(ratio,2)+")",font.size,use.font,FontColor);//
        
       ObjectSet(ObjName,OBJPROP_ANGLE,label.angle);
       WindowRedraw();
     }
     //Comment("d1z "+d1z + " d2z "+d2z+"(checkit) "+checkit  + " t1z "+t1z  + " Time[y] "+Time[y]);
     
   }
   return(0);
  }
//+------------------------------------------------------------------+